<section class="main">
    <mat-sidenav-container [hasBackdrop]="false">
        <mat-sidenav class="sidenav" #sidenavParticipants mode="over" position="end">
            <mat-toolbar style="background-color: #ffffff;">
                <p fxFlexAlign="center" class="name">Participants
                    ({{participantCount}})</p>
                <span class="example-spacer"></span>
                <mat-icon fxFlexAlign="center" (click)="sidenavParticipants.toggle()" class="icon">keyboard_arrow_down
                </mat-icon>
            </mat-toolbar>
            <mat-divider></mat-divider>
            <div *ngIf="activeRoom" style="padding: 16px; overflow-y: auto">
                <ng-container *ngFor="let participant of getParticipants()">
                    <div fxLayout="row" fxLayoutAlign="start center">
                        <p class="avatar">{{getUserInitial(participant.identity)}}</p>
                        <p class="user-identity">{{participant.identity}} {{hostIdentity(participant.identity)}}</p>
                        <button [disabled]="isDisabled(participant)" mat-icon-button (click)="toggleVoice(participant)">
                            <mat-icon
                                    style="margin: auto">{{muteEventValue.get(participant?.sid) ? 'mic_none' : 'mic_off'}}</mat-icon>
                        </button>
                    </div>
                </ng-container>
            </div>

        </mat-sidenav>

        <!--full screen toggle and view toggle-->
        <div fxShow="true" fxHide.lt-sm="true" fxLayout="row" class="toggle-actions">
            <button mat-button class="view-layout" (click)="toggleView()">
                <mat-icon>view_module</mat-icon>
                {{speakerView ? 'Speaker View' : 'Gallery View'}}
            </button>
            <button mat-button class="full-screen" (click)="openFullscreen()">
                <mat-icon>{{!fullScreen ? 'fullscreen' : 'fullscreen_exit'}}</mat-icon>
                {{!fullScreen ? 'Enter FullScreen' : 'Exit FullScreen'}}
            </button>
        </div>
        <!--joining-->
        <div *ngIf="isJoining" class="joining" fxLayoutAlign="center">
            <mat-card fxFlex="20%" fxFlex.lt-sm="40%">
                <mat-card-content class="text-center">
                    <div fxLayout="row" fxLayoutAlign="center">
                        <mat-spinner fxFlexAlign="center" [diameter]="20" strokeWidth="1dp"></mat-spinner>
                        <p style="margin: auto"><strong>Joining ...</strong></p>
                    </div>
                </mat-card-content>
            </mat-card>
        </div>


        <!--participants small previews-->
        <div [ngClass]="speakerView? 'hide' : 'show'" class="preview-small" [ngClass.lt-md]="speakerView? 'hide' : 'preview-small-md'" [ngClass.lt-sm]="speakerView? 'hide' : 'preview-small-sm'">
            <div fxLayout="row" fxLayoutAlign="end center" class="max-min">
                <button (click)="togglePreviews()" mat-icon-button>
                    <mat-icon>minimize</mat-icon>
                </button>
                <button mat-icon-button (click)="togglePreviews()">
                    <mat-icon>view_stream</mat-icon>
                </button>
            </div>
            <div class="all-preview" [ngClass]="minimizePreview? 'hide' : 'show'">
                <ng-container *ngFor="let participant of getParticipants()">
                    <app-preview class="my-preview" [id]="participant.sid + 'sv'" [participant]="participant"
                                 [isHost]="isHost"
                                 [hostIdentity]="hostIdentity(participant.identity)"
                                 [localParticipant]="localParticipant"
                                 (updateMute)="updateMute($event)"
                                 (screenTrack)="setScreenTrack($event)"
                                 (currentMuteState)="currentMuteState()"
                                 [micOn]="muteEventValue?.get(participant?.sid)"
                                 (muted)="muteEvent($event)">
                    </app-preview>
                </ng-container>
            </div>
        </div>
        <!--speaker view and screen shareView-->

        <div [ngClass]="speakerView? 'hide' : 'show'" class="preview">
            <app-speaker-view [participant]="dominantSpeaker"
                              [localParticipant]="localParticipant"
                              [presentationTrack]="presentationTrack">
            </app-speaker-view>
        </div>

        <!--gallery view-->
        <div [ngClass]="!speakerView? 'hide' : 'show'" class="preview">
            <div id="video-gallery-container">
                <div id="video-gallery">
                    <ng-container *ngFor="let participant of getParticipants()">
                        <app-gallery-preview [id]="participant.sid + 'gv'" [participant]="participant"
                                             [isHost]="isHost"
                                             [hostIdentity]="hostIdentity(participant.identity)"
                                             [localParticipant]="localParticipant"
                                             [micOn]="muteEventValue?.get(participant?.sid)"
                                             (muted)="muteEvent($event)"
                                             (currentMuteState)="currentMuteState()"
                                             [count]="getParticipants().length"
                                             (updateMute)="updateMute($event)"
                                             (screenTrack)="setScreenTrack($event)"
                                             class="video-container">
                        </app-gallery-preview>
                    </ng-container>
                </div>
            </div>
        </div>

        <!--full screen bar-->
        <div *ngIf="fullScreen" (mouseenter)="showFullScreenBar = true" (mouseleave)="showFullScreenBar = false"
             class="full-screen-bar">
            <div *ngIf="showFullScreenBar" fxLayout="row" fxFlexFill fxLayoutAlign="space-evenly center"
                 class="full-screen-bar-items">
                <button mat-button (click)="toggleVoice(activeRoom?.localParticipant)" fxLayout="column"
                        fxLayoutAlign="center center">
                    <mat-icon fontSet="material-icons-outlined" fxFlexAlign="center"
                              [ngClass]="{ 'icon-on': muteEventValue.get(activeRoom?.localParticipant?.sid), 'icon-off': !muteEventValue.get(activeRoom?.localParticipant?.sid) }">
                        {{muteEventValue.get(activeRoom?.localParticipant?.sid) ? 'mic_none' : 'mic_off'}}
                    </mat-icon>
                    <p>Mic</p>
                </button>
                <button fxShow="true" fxHide.lt-sm="true" fxLayoutAlign="center center" fxLayout="column"
                        (click)="invite()" mat-button>
                    <mat-icon fontSet="material-icons-outlined" fxFlexAlign="center" class="icon-on">
                        person_add
                    </mat-icon>
                    <p>Invite</p>
                </button>
                <button fxShow="true" fxHide.lt-sm="true" fxLayoutAlign="center center" fxLayout="column"
                        (click)="sidenavParticipants.toggle()" mat-button>
                    <mat-icon fxFlexAlign="center"
                              fontSet="material-icons-outlined"
                              matBadge="{{participantCount}}"
                              matBadgePosition="above after" class="icon-on">
                        group
                    </mat-icon>
                    <p>Manage Participants</p>
                </button>
                <button (click)="present()" fxLayoutAlign="center center" fxLayout="column" mat-button>
                    <mat-icon fontSet="material-icons-outlined" fxFlexAlign="center"
                              [ngClass]="{'active-action': isPresenting, 'inactive-action': !isPresenting}">
                        present_to_all
                    </mat-icon>
                    <p>Share</p>
                </button>
            </div>
        </div>

        <!--bottom bar-->
        <div [hidden]="fullScreen" id="bottomBar">
            <mat-toolbar [ngClass]="{'hidden':!showToolbar}">
                <div fxFlex="0 1 calc(20% - 16px)" fxLayout="row">
                    <button mat-button (click)="toggleVoice(activeRoom?.localParticipant)" fxLayout="column"
                            fxLayoutAlign="center center">
                        <mat-icon fontSet="material-icons-outlined" fxFlexAlign="center"
                                  [ngClass]="{ 'icon-on': muteEventValue.get(activeRoom?.localParticipant?.sid), 'icon-off': !muteEventValue.get(activeRoom?.localParticipant?.sid) }">
                            {{muteEventValue.get(activeRoom?.localParticipant?.sid) ? 'mic_none' : 'mic_off'}}
                        </mat-icon>
                        <p>Mic</p>
                    </button>
                </div>
                <div fxFlex="0 1 calc(60% - 16px)" fxLayoutGap="32px" fxLayout="row" fxLayoutAlign="center">
                    <button fxShow="true" fxHide.lt-sm="true" fxLayoutAlign="center center" fxLayout="column"
                            (click)="invite()" mat-button>
                        <mat-icon fontSet="material-icons-outlined" fxFlexAlign="center" class="icon-on">
                            person_add
                        </mat-icon>
                        <p>Invite</p>
                    </button>
                    <button fxShow="true" fxHide.lt-sm="true" fxLayoutAlign="center center" fxLayout="column"
                            (click)="sidenavParticipants.toggle()" mat-button>
                        <mat-icon fxFlexAlign="center"
                                  fontSet="material-icons-outlined"
                                  matBadge="{{participantCount}}"
                                  matBadgePosition="above after" class="icon-on">
                            group
                        </mat-icon>
                        <p>Manage Participants</p>
                    </button>
                    <button (click)="present()" fxShow="true" fxHide.lt-sm="true" fxLayoutAlign="center center"
                            fxLayout="column" mat-button>
                        <mat-icon fontSet="material-icons-outlined" fxFlexAlign="center"
                                  [ngClass]="{'active-action': isPresenting, 'inactive-action': !isPresenting}">
                            present_to_all
                        </mat-icon>
                        <p>Share</p>
                    </button>
                </div>

                <div fxFlex="0 1 calc(10% - 16px)" fxLayout="row">
                    <button [disabled]="activeRoom === null" fxFlexAlign="center" mat-button
                            class="btn-end" (click)="leaveRoom()">End Event
                    </button>
                    <button style="color: white" fxHide="true" fxShow.lt-sm="true" fxFlexAlign="end" mat-button
                            [matMenuTriggerFor]="contextMenu" fxLayout="column"
                            fxLayoutAlign="center center">
                        <mat-icon>more_vert</mat-icon>
                        <p>More</p>
                    </button>
                </div>
            </mat-toolbar>
        </div>
    </mat-sidenav-container>
</section>

<mat-menu #contextMenu="matMenu">
    <button mat-menu-item (click)="toggleView()">
        <mat-icon>view_module</mat-icon>
        {{speakerView ? 'Speaker View' : 'Gallery View'}}
    </button>
    <button mat-menu-item (click)="openFullscreen()">
        <mat-icon>{{!fullScreen ? 'fullscreen' : 'fullscreen_exit'}}</mat-icon>
        {{!fullScreen ? 'Enter FullScreen' : 'Exit FullScreen'}}
    </button>
    <button mat-menu-item (click)="invite()">
        <mat-icon>person_add</mat-icon>
        Invite
    </button>
    <button mat-menu-item (click)="sidenavParticipants.toggle()">
        <mat-icon matBadge="{{participantCount}}" matBadgePosition="above after">group</mat-icon>
        Manage Participants
    </button>
</mat-menu>

